<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10                                //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2011                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

    if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') { die(); }
    header('Content-Type: text/html; charset=utf-8');
    session_start();

    if (!isset($_REQUEST['module_id'])) { die(2); }
    if (!isset($_REQUEST['page'])) { die(4); }

    define("VALID_CMS", 1);
    define('PATH', $_SERVER['DOCUMENT_ROOT']);

    // Грузим ядро и классы
    include(PATH.'/core/cms.php');
    // Грузим конфиг
    include(PATH.'/includes/config.inc.php');
    $inCore = cmsCore::getInstance();

    define('HOST', 'http://' . $inCore->getHost());

    $inCore->loadClass('config');
    $inCore->loadClass('db');
    $inCore->loadClass('user');
    $inCore->loadClass('page');
    $inDB   = cmsDatabase::getInstance();
    setlocale(LC_ALL, 'en_US');
    // Подгружаем языковой файл
    $inCore->loadLanguage('lang');
    $inCore->loadLanguage('modules/mod_latestcol');

    // Грузим шаблонизатор
    $smarty = $inCore->initSmarty();

    // Входные данные
    $page        = $inCore->request('page', 'int', 1);
    $module_id    = $inCore->request('module_id', 'int', '');

    // Грузим конфиг модуля
    $cfg = $inCore->loadModuleConfig($module_id);
    // Если пагинация отключена, выходим
    if (!$cfg['is_pag']) { die(); }

    $perpage    = $cfg['newscount'];

        if (!isset($cfg['showrss'])) { $cfg['showrss'] = 1; }
        if (!isset($cfg['subs'])) { $cfg['subs'] = 1; }
        if (!isset($cfg['manual_ids'])) { $cfg['manual_ids'] = 0; }
        if (!isset($cfg['newscount'])) { $cfg['newscount'] = 4; }
        if (!isset($cfg['cat_id'])) { $cfg['cat_id'] = 1; }
        if (!isset($cfg['in_cat_id'])) { $cfg['in_cat_id'] = ''; }
        if (!isset($cfg['cols'])) { $cfg['cols'] = 2; }
        if (!isset($cfg['img_width'])) { $cfg['img_width'] = 64; }
        if (!isset($cfg['img_height'])) { $cfg['img_height'] = 64; }
        if (!isset($cfg['b_color'])) { $cfg['b_color'] = '#000000'; }
        if (!isset($cfg['show_img'])) { $cfg['show_img'] = 0; }
        if (!isset($cfg['target'])) { $cfg['target'] = 1; }
        if (!isset($cfg['title_max_char'])) { $cfg['title_max_char'] = 50; }
        if (!isset($cfg['title_replacer'])) { $cfg['title_replacer'] = "…"; }
        if (!isset($cfg['title_style'])) { $cfg['title_style'] = "margin:0; font-weight: bold; font-size: 16px; color:#B5AE6A"; }
        if (!isset($cfg['title_strict'])) { $cfg['title_strict'] = 0; }
        if (!isset($cfg['max_char'])) { $cfg['max_char'] = 200; }
        if (!isset($cfg['replacer'])) { $cfg['replacer'] = " ... "; }
        if (!isset($cfg['strict'])) { $cfg['strict'] = 0; }
        if (!isset($cfg['middle'])) { $cfg['middle'] = 1; }
        if (!isset($cfg['img_name'])) { $cfg['img_name'] = 'kate.png'; }
        if (!isset($cfg['first_img'])) { $cfg['first_img'] = 1; }

    $today = date("Y-m-d H:i:s");

if (!$cfg['manual_ids']){
    if ($cfg['cat_id'] != '-1') {
            if (!$cfg['subs']){
                //select from category
                $catsql = ' AND con.category_id = '.$cfg['cat_id'];
            } else {
                //select from category and subcategories
                $rootcat = $inDB->get_fields('cms_category', "id='{$cfg['cat_id']}'", 'NSLeft, NSRight');
                if(!$rootcat) { exit; }
                $catsql = "AND (cat.NSLeft >= {$rootcat['NSLeft']} AND cat.NSRight <= {$rootcat['NSRight']})";
            }
            $rssid = $cfg['cat_id'];

    } else { $catsql = ''; $rssid = 'all'; }
} else {
        $cat_list = array();
        foreach($cfg['in_cat_id'] as $cat_id){
            $cat_list[] = $cat_id;
        }
        $cat_list = rtrim(implode(',', $cat_list), ',');
        $catsql = ' AND con.category_id IN ('.$cat_list.')';
}

    $sql = "SELECT con.*,
                       con.pubdate as fdate,
                       u.nickname as author,
                       u.login as author_login
                       FROM cms_content con
                       LEFT JOIN cms_category cat ON cat.id = con.category_id
                       LEFT JOIN cms_users u ON u.id = con.user_id
                       WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today'
                       AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today'))
                       ".$catsql."
                       ORDER BY con.pubdate DESC
                       LIMIT ".(($page-1)*$perpage).", $perpage";

    $result = $inDB->query($sql);

    $is_con = false;

    // Считаем общее количество материалов
    $sql_total = "SELECT 1
            FROM cms_content con
            LEFT JOIN cms_category cat ON cat.id = con.category_id
            WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today' AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today')) ".$catsql."";
    $result_total = $inDB->query($sql_total) ;
    $total_page = $inDB->num_rows($result_total);

    // если есть записи выводим их
    if ($total_page){

        $is_con = true;

        // грузим модель компонента контент
        $inCore->loadModel('content');
        $model = new cms_model_content();

        $articles = array();
        while($con = $inDB->fetch_assoc($result)){
                $next = sizeof($articles);
                $articles[$next]['id']          = $con['id'];
                $articles[$next]['title']       = $con['title'];
                $articles[$next]['hits']        = $con['hits'];
                $articles[$next]['href']        = $model->getArticleURL(null, $con['seolink']);
                $articles[$next]['author']      = $con['author'];
                $articles[$next]['authorhref']  = cmsUser::getProfileURL($con['author_login']);
                $articles[$next]['comments']    = $cfg['showcom'] ? $inCore->getCommentsCount('article', $con['id']) : false;
                $articles[$next]['date']        = $inCore->dateformat($con['fdate']);
                $articles[$next]['description'] = mb_strlen($con['description']) > 20 ? $con['description'] : $con['content'];
                $inCore->processFilters( $articles[$next]['description']);

                if ($cfg['first_img']){
                    $in_desc = preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/is', $con['description'], $matches);
                    if (!$in_desc) { preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/is', $con['content'], $matches); }
                    if ($matches[1]){
                        $test_out = $matches[1];
                        if (preg_match('/http|https/', $test_out)){
                            $law_img = imagecreatefromstring(file_get_contents($test_out));
                            if ($law_img) {
                                $articles[$next]['first_image'] = $test_out;
                            }
                        }
                        else if (file_exists(PATH.$matches[1])) {
                            $articles[$next]['first_image'] = $matches[1];
                        }
                    } else {
                        $articles[$next]['first_image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? '/images/photos/small/article'.$con['id'].'.jpg' : '');
                    }
                } else {
                    $articles[$next]['image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? 'article'.$con['id'].'.jpg' : '');
                }
        }
    }

    // Отдаем в шаблон
    ob_start();
    $smarty = $inCore->initSmarty('modules', 'mod_latestcol.tpl');
    $smarty->assign('articles', $articles);
    $smarty->assign('rssid', $rssid);
    $smarty->assign('cfg', $cfg);
    $smarty->assign('is_ajax', true);
    $smarty->assign('is_con', $is_con);
    $smarty->assign('module_id', $module_id);
    $smarty->assign('pagebar_module', cmsPage::getPagebar($total_page, $page, $perpage, 'javascript:conPageCol(%page%, '.$module_id.')'));
    $smarty->display('mod_latestcol.tpl');
    $html = ob_get_clean();
    echo $html;
?>
